<?php 
require_once("icwfData.inc.php");
require_once("FormValidation.inc.php");

class Disclaimer implements icwfData {
  private static $noExport = array();
  private static $notInArray = array("validation");
  private $validation;
  
  private $disclaimer_id;
  private $disclaimer_name;
  private $disclaimer;
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // initialize
  private function initialize() {
    foreach ($this as $key => $value)
      $this->$key = null;
  }
  
  public function __construct(FormValidation $validation=null) {
    $this->initialize();
    
    $this->validation = $validation;
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // get values
  public function __get($name) {
    if($name == "id") $name = "disclaimer_id";
    if (array_key_exists($name, get_class_vars(get_class())) && !in_array($name, self::$noExport))
      return $this->$name;
      
    return null;
  }

  public function getIDName() {
    return "disclaimer_id";
  }
  
  public function toArray() {
    $array = array();
    foreach ($this as $key => $value)
      if(!in_array($key, self::$notInArray))
        $array[$key] = $value; 
    return $array;
  }
  
  public function getPostBackData() {
    return array($this->getIDName()=>$this->id);
  }
  
  ////////////////////////////////////////////////////////////////////////////////////////////////
  // set values
  public function setValidation(FormValidation $validation) {
    $this->validation = $validation;
  }
  
  public function fromArray($array) {
    
    foreach ($this as $key => $value) {
      switch ($key) {
        case "validation":
          break;
          
        case "disclaimer_id":
          if(isset($array[$key]) && preg_match('~^[0-9]+$~', $array[$key]))
            $this->$key = $array[$key];
          else
            $this->$key = null;
          break;

        default:
          if(isset($array[$key]))
            $this->$key = $array[$key];
          else
            $this->$key = null;
          break;
      }
    }
    return $this->validation->validate($array);
  }

  /////////////////////////////////////////////////////////////////////////////////////////////////
  // database operations - read
  public function readData(DbConnection $DB, $conditions) {
    $whereConditions = array();
    foreach ($conditions as $key => $value)
      if(array_key_exists($key, get_class_vars(get_class())))
        $whereConditions[] = "$key=$value";
    
    $result = $DB->query("SELECT * FROM disclaimers WHERE ".implode(" AND ", $whereConditions).";");
    
    if(!$DB->errno() && $DB->num_rows($result)>0) {
      $group = $DB->fetch_array($result);
      foreach ($group as $property => $value)
        if(property_exists($this, $property))
          $this->$property = $value;
      
      return array(0, "");
    }
    else
      return array($DB->errno(), $DB->error());
  }
  
  static public function readList(DbConnection $DB) {
    $result = $DB->query("SELECT disclaimer_id id, disclaimer_name name FROM disclaimers ORDER BY disclaimer_name;");
    
    $list = array();
    while ($disclaimer = $DB->fetch_array($result))
      $list[] = $disclaimer;
      
    return $list;
  }

  /////////////////////////////////////////////////////////////////////////////////////////////////
  // database operations - write
  public function writeData(DbConnection $DB) {
    if(!isset($this->disclaimer_name) || !$this->disclaimer_name) return;
    if(isset($this->disclaimer_id) && $this->disclaimer_id) {
      $result = $DB->query("UPDATE disclaimers SET
          disclaimer_name='{$this->disclaimer_name}',
          disclaimer='{$this->disclaimer}'
        WHERE disclaimer_id='{$this->disclaimer_id}';");
      $logEntry = "Disclaimer '{$this->disclaimer_id}' changed.";
    }
    else {
      $result = $DB->query("INSERT INTO disclaimers(
          disclaimer_name,
          disclaimer
        ) VALUES(
          '{$this->disclaimer_name}',
          '{$this->disclaimer}'
        );");
      
      $this->disclaimer_id = $DB->insert_id();
      $logEntry = "Disclaimer '{$this->disclaimer_id}' created.";
    }
    if(!$DB->errno()) {
      KDbLog::writeLog($DB, $logEntry);
      return array(0, "");
    }
    else
      return array($DB->errno(), $DB->error());
  }

  static public function deleteData(DbConnection $DB, $id) {
    if(preg_match("~^[0-9]+$~", $id))
      $condition = "disclaimer_id='{$id}'";
    else
      $condition = $id;

    $result = $DB->query("DELETE FROM disclaimers WHERE {$condition};");
    
    if(!$DB->errno() && $DB->affected_rows()>0) {
      KDbLog::writeLog($DB, "Disclaimer(s) deleted ($condition).");
      return array(0, "");
    }
    else 
      return array($DB->errno(), $DB->error());
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // database operations - misc
  static public function createTable(DbConnection $DB) {
    $result = $DB->query("
      CREATE TABLE disclaimers (
        disclaimer_id int unsigned NOT NULL AUTO_INCREMENT PRIMARY KEY,
        disclaimer_name text,
        disclaimer text
      );");
    if ($result) { echo _("&nbsp;&nbsp;- creating table").": 'disclaimers'.<br>\n"; }
    else { echo _("&nbsp;&nbsp;<b>- Error when creating table</b>")." 'disclaimers'<br>\n"; $error = 1; }
  }
}
?>