<?php
require_once("cwfUI.inc.php");

class SendEmailUI extends cwfUI {
  protected static $accessRight = "";
  protected static $dataClass = "DbAdmin";
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // initialize
  public function __construct() {
    parent::__construct();
    $this->initialize();
  }
  
  protected function initialize() {
    parent::initialize();
    $this->title = _("Send Email");
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // security
  static public function isAllowedAction($action) {
    return in_array($action, array("sendEmail"));
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // handle data
  static public function getValidationRules() {
    $rules = array();
    $messages = array();
    
    $validationRules = new FormValidation($rules, $messages);
    return $validationRules;
  }
  
  public function isValid() {
    return true;
  }
  
  public function getInvalidFields() {
    return array();
  }

  public function getPostBackXML(DbConnection $DB, $action) {
    $xml = "";
    return $xml;
  }
  
  public function doAction(DbConnection $DB, $action) {
    $id = "";
    switch ($action) {
      case "sendEmail":
        $this->sendEmail($DB);
        $id = null;
        break;
    }
    return $id;
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // Database operations
  public function sendEmail(DbConnection $DB) {
    foreach ($_POST['admins'] as $adminId) {
      $admin = new DbAdmin();
      $admin->readData($DB, array("{$admin->getIDName()}"=>"'{$adminId}'"));
      if($admin->email)
        CWFTools::sendEmail($admin->email, $_POST['email_text'], $_POST['email_subject'], KDbConfig::getRootEmail());
    }
  }
  
  /////////////////////////////////////////////////////////////////////////////////////////////////
  // output
  public function getHTML(DbConnection $DB) {
?>
<form id="kdb_form" action="" method="post" enctype="multipart/form-data">
<div class="form_controls_top">
<p>
  <input type="submit" id="kdb_email" name="kdb_email" value="<?=_("Send email")?>" onClick="kdbSaveEntry('SendEmailUI', 'sendEmail'); return false;">
</p>
</div>

<h3 class="first"><?=_("Send Email")?></h3>

<p>
  <label for="admins"><?=_("Recipients")?>:</label>
  <select id="admins" name="admins[]" multiple size="10">
  <?php
      $admins = DbAdmin::readList($DB);
      foreach ($admins as $admin)
        echo "    <option value=\"{$admin['id']}\">{$admin['name']}</option>\n";
  ?>
  </select>
</p>

<p>
  <label for="email_subject"><?=_("Subject")?>:</label>
  <input type="text" id="email_subject" name="email_subject" value="">
</p>

<p>
  <label for="email_text"><?=_("Email text")?>:</label>
  <textarea id="email_text" name="email_text"></textarea>
</p>

<div class="form_controls_bottom">
<p>
  <input type="submit" id="kdb_email2" name="kdb_email" value="<?=_("Send email")?>" onClick="kdbSaveEntry('SendEmailUI', 'sendEmail'); return false;">
</p>
</div>
</form>
<?php
  }
}

?>